// java wrapper for vtkIdTypeArray object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkIdTypeArray.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataArray_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkIdTypeArray_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkIdTypeArray",dType)) { return me; }
  if ((res= vtkDataArray_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkIdTypeArray *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkIdTypeArray *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_GetDataType_12(JNIEnv *env, jobject obj)
{
  vtkIdTypeArray *op;
  int      temp20;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDataType();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_GetValue_13(JNIEnv *env, jobject obj,jint id0)
{
  vtkIdTypeArray *op;
  vtkIdType   temp0;
  vtkIdType   temp20;
  temp0 = id0;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetValue(temp0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkIdTypeArray_SetValue_14(JNIEnv *env, jobject obj,jint id0,jint id1)
{
  vtkIdTypeArray *op;
  vtkIdType   temp0;
  vtkIdType   temp1;
  temp0 = id0;
  temp1 = id1;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  op->SetValue(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkIdTypeArray_SetNumberOfValues_15(JNIEnv *env, jobject obj,jint id0)
{
  vtkIdTypeArray *op;
  vtkIdType   temp0;
  temp0 = id0;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNumberOfValues(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkIdTypeArray_InsertValue_16(JNIEnv *env, jobject obj,jint id0,jint id1)
{
  vtkIdTypeArray *op;
  vtkIdType   temp0;
  vtkIdType   temp1;
  temp0 = id0;
  temp1 = id1;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  op->InsertValue(temp0,temp1);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_InsertNextValue_17(JNIEnv *env, jobject obj,jint id0)
{
  vtkIdTypeArray *op;
  vtkIdType   temp0;
  vtkIdType   temp20;
  temp0 = id0;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->InsertNextValue(temp0);
  return temp20;
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkIdTypeArray_GetValueRange_18(JNIEnv *env, jobject obj,jint id0)
{
  vtkIdTypeArray *op;
  int      temp0;
  vtkIdType  *temp20;
  temp0 = id0;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetValueRange(temp0);
    return vtkJavaMakeJArrayOfIntFromIdType(env,temp20,2);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkIdTypeArray_GetValueRange_19(JNIEnv *env, jobject obj)
{
  vtkIdTypeArray *op;
  vtkIdType  *temp20;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetValueRange();
    return vtkJavaMakeJArrayOfIntFromIdType(env,temp20,2);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkIdTypeArray_FastDownCast_110(JNIEnv *env, jobject obj,jobject id0)
{
  vtkIdTypeArray *op;
  vtkAbstractArray  *temp0;
  vtkIdTypeArray  *temp20;
  temp0 = (vtkAbstractArray *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->FastDownCast(temp0);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_GetDataTypeValueMin_111(JNIEnv *env, jobject obj)
{
  vtkIdTypeArray *op;
  vtkIdType   temp20;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDataTypeValueMin();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkIdTypeArray_GetDataTypeValueMax_112(JNIEnv *env, jobject obj)
{
  vtkIdTypeArray *op;
  vtkIdType   temp20;

  op = (vtkIdTypeArray *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDataTypeValueMax();
  return temp20;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkIdTypeArray_VTKInit(JNIEnv *, jobject)
{
  vtkIdTypeArray *aNewOne = vtkIdTypeArray::New();
  return (jlong)(size_t)(void*)aNewOne;
}
