// java wrapper for vtkHyperTreeGrid object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkHyperTreeGrid.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkDataSet_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkHyperTreeGrid_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkHyperTreeGrid",dType)) { return me; }
  if ((res= vtkDataSet_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_LEVELS_10(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkInformationIntegerKey  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->LEVELS();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_DIMENSION_11(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkInformationIntegerKey  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->DIMENSION();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_ORIENTATION_12(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkInformationIntegerKey  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ORIENTATION();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_SIZES_13(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkInformationDoubleVectorKey  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->SIZES();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_IsTypeOf_14(JNIEnv *env, jobject obj,jstring id0)
{
  vtkHyperTreeGrid *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_IsA_15(JNIEnv *env, jobject obj,jstring id0)
{
  vtkHyperTreeGrid *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetDataObjectType_16(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDataObjectType();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_CopyStructure_17(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkDataSet  *temp0;
  temp0 = (vtkDataSet *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->CopyStructure(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetGridSize_18(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp0;
   unsigned int      temp1;
   unsigned int      temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetGridSize(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetGridExtent_19(JNIEnv *env, jobject obj,jintArray id0)
{
  vtkHyperTreeGrid *op;
  int    temp0[6];
  void *tempArray0;
  tempArray0 = (void *)(env->GetIntArrayElements(id0,nullptr));
  temp0[0] = ((jint *)tempArray0)[0];
  temp0[1] = ((jint *)tempArray0)[1];
  temp0[2] = ((jint *)tempArray0)[2];
  temp0[3] = ((jint *)tempArray0)[3];
  temp0[4] = ((jint *)tempArray0)[4];
  temp0[5] = ((jint *)tempArray0)[5];

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetGridExtent(temp0);
  ((jint *)tempArray0)[0] = temp0[0];
  ((jint *)tempArray0)[1] = temp0[1];
  ((jint *)tempArray0)[2] = temp0[2];
  ((jint *)tempArray0)[3] = temp0[3];
  ((jint *)tempArray0)[4] = temp0[4];
  ((jint *)tempArray0)[5] = temp0[5];
  env->ReleaseIntArrayElements(id0,(jint *)tempArray0,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetGridExtent_110(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  vtkHyperTreeGrid *op;
  int      temp0;
  int      temp1;
  int      temp2;
  int      temp3;
  int      temp4;
  int      temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetGridExtent(temp0,temp1,temp2,temp3,temp4,temp5);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetTransposedRootIndexing_111(JNIEnv *env, jobject obj,jboolean id0)
{
  vtkHyperTreeGrid *op;
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetTransposedRootIndexing(temp0);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkHyperTreeGrid_GetTransposedRootIndexing_112(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  bool   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTransposedRootIndexing();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetIndexingModeToKJI_113(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIndexingModeToKJI();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetIndexingModeToIJK_114(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIndexingModeToIJK();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetDimension_115(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp0;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetDimension(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetDimension_116(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDimension();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetOrientation_117(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp0;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOrientation(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetOrientation_118(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOrientation();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetBranchFactor_119(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp0;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBranchFactor(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetBranchFactor_120(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBranchFactor();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfTrees_121(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfTrees();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfVertices_122(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfVertices();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfLeaves_123(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfLeaves();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfCells_124(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfCells();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfPoints_125(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfPoints();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfLevels_126(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkIdType   temp20;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfLevels(temp0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfLevels_127(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfLevels();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetXCoordinates_128(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkDataArray  *temp0;
  temp0 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetXCoordinates(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetXCoordinates_129(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkDataArray  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetXCoordinates();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetYCoordinates_130(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkDataArray  *temp0;
  temp0 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetYCoordinates(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetYCoordinates_131(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkDataArray  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetYCoordinates();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetZCoordinates_132(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkDataArray  *temp0;
  temp0 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetZCoordinates(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetZCoordinates_133(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkDataArray  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetZCoordinates();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetMaterialMask_134(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkBitArray  *temp0;
  temp0 = (vtkBitArray *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetMaterialMask(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetMaterialMask_135(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkBitArray  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaterialMask();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkHyperTreeGrid_HasMaterialMask_136(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  bool   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->HasMaterialMask();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetMaterialMaskIndex_137(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkIdTypeArray  *temp0;
  temp0 = (vtkIdTypeArray *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetMaterialMaskIndex(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetMaterialMaskIndex_138(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkIdTypeArray  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaterialMaskIndex();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetHasInterface_139(JNIEnv *env, jobject obj,jboolean id0)
{
  vtkHyperTreeGrid *op;
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetHasInterface(temp0);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkHyperTreeGrid_GetHasInterface_140(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  bool   temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetHasInterface();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_HasInterfaceOn_141(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->HasInterfaceOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_HasInterfaceOff_142(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->HasInterfaceOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetInterfaceNormalsName_143(JNIEnv *env, jobject obj,jstring id0)
{
  vtkHyperTreeGrid *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInterfaceNormalsName(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkHyperTreeGrid_GetInterfaceNormalsName_144(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  char    *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetInterfaceNormalsName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetInterfaceInterceptsName_145(JNIEnv *env, jobject obj,jstring id0)
{
  vtkHyperTreeGrid *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInterfaceInterceptsName(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkHyperTreeGrid_GetInterfaceInterceptsName_146(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  char    *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetInterfaceInterceptsName();
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_GenerateTrees_147(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->GenerateTrees();
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_NewCursor_148(JNIEnv *env, jobject obj,jint id0,jboolean id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  bool   temp1;
  vtkHyperTreeCursor  *temp20;
  temp0 = id0;
  temp1 = (id1 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->NewCursor(temp0,temp1);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_NewGridCursor_149(JNIEnv *env, jobject obj,jint id0,jboolean id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  bool   temp1;
  vtkHyperTreeGridCursor  *temp20;
  temp0 = id0;
  temp1 = (id1 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->NewGridCursor(temp0,temp1);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_NewGeometricCursor_150(JNIEnv *env, jobject obj,jint id0,jboolean id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  bool   temp1;
  vtkHyperTreeGridCursor  *temp20;
  temp0 = id0;
  temp1 = (id1 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->NewGeometricCursor(temp0,temp1);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_NewVonNeumannSuperCursor_151(JNIEnv *env, jobject obj,jint id0,jboolean id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  bool   temp1;
  vtkHyperTreeGridCursor  *temp20;
  temp0 = id0;
  temp1 = (id1 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->NewVonNeumannSuperCursor(temp0,temp1);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_NewMooreSuperCursor_152(JNIEnv *env, jobject obj,jint id0,jboolean id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  bool   temp1;
  vtkHyperTreeGridCursor  *temp20;
  temp0 = id0;
  temp1 = (id1 != 0) ? true : false;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->NewMooreSuperCursor(temp0,temp1);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SubdivideLeaf_153(JNIEnv *env, jobject obj,jobject id0,jint id1)
{
  vtkHyperTreeGrid *op;
  vtkHyperTreeCursor  *temp0;
  vtkIdType   temp1;
  temp0 = (vtkHyperTreeCursor *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = id1;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SubdivideLeaf(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_GetPoint_154(JNIEnv *env, jobject obj,jint id0,jdoubleArray id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  double temp1[3];
  void *tempArray1;
  temp0 = id0;
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];
  temp1[2] = ((jdouble *)tempArray1)[2];

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->GetPoint(temp0,temp1);
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  ((jdouble *)tempArray1)[2] = temp1[2];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetCell_155(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkCell  *temp20;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCell(temp0);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetCell_156(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2)
{
  vtkHyperTreeGrid *op;
  int      temp0;
  int      temp1;
  int      temp2;
  vtkCell  *temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCell(temp0,temp1,temp2);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_GetCell_157(JNIEnv *env, jobject obj,jint id0,jobject id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkGenericCell  *temp1;
  temp0 = id0;
  temp1 = (vtkGenericCell *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->GetCell(temp0,temp1);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetCellType_158(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  int      temp20;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCellType(temp0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_GetCellPoints_159(JNIEnv *env, jobject obj,jint id0,jobject id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkIdList  *temp1;
  temp0 = id0;
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->GetCellPoints(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_GetPointCells_160(JNIEnv *env, jobject obj,jint id0,jobject id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkIdList  *temp1;
  temp0 = id0;
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->GetPointCells(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_GetCellNeighbors_161(JNIEnv *env, jobject obj,jint id0,jobject id1,jobject id2)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkIdList  *temp1;
  vtkIdList  *temp2;
  temp0 = id0;
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->GetCellNeighbors(temp0,temp1,temp2);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_FindPoint_162(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkHyperTreeGrid *op;
  double temp0[3];
  void *tempArray0;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->FindPoint(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_Initialize_163(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->Initialize();
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetTree_164(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkHyperTree  *temp20;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTree(temp0);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_SetTree_165(JNIEnv *env, jobject obj,jint id0,jobject id1)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  vtkHyperTree  *temp1;
  temp0 = id0;
  temp1 = (vtkHyperTree *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->SetTree(temp0,temp1);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetMaxCellSize_166(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaxCellSize();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_ShallowCopy_167(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkDataObject  *temp0;
  temp0 = (vtkDataObject *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->ShallowCopy(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkHyperTreeGrid_DeepCopy_168(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkDataObject  *temp0;
  temp0 = (vtkDataObject *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  op->DeepCopy(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetExtentType_169(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetExtentType();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetActualMemorySize_170(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
   unsigned long     temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetActualMemorySize();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetNumberOfChildren_171(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfChildren();
  return temp20;
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkHyperTreeGrid_RecursivelyInitializePureMaterialMask_172(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkHyperTreeGridCursor  *temp0;
  bool   temp20;
  temp0 = (vtkHyperTreeGridCursor *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->RecursivelyInitializePureMaterialMask(temp0);
  return temp20;
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetPureMaterialMask_173(JNIEnv *env, jobject obj)
{
  vtkHyperTreeGrid *op;
  vtkBitArray  *temp20;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetPureMaterialMask();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetChildMask_174(JNIEnv *env, jobject obj,jint id0)
{
  vtkHyperTreeGrid *op;
   unsigned int      temp0;
   unsigned int      temp20;
  temp0 = id0;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetChildMask(temp0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkHyperTreeGrid_GetShiftedLevelZeroIndex_175(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2,jint id3)
{
  vtkHyperTreeGrid *op;
  vtkIdType   temp0;
  int      temp1;
  int      temp2;
  int      temp3;
   unsigned int      temp20;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetShiftedLevelZeroIndex(temp0,temp1,temp2,temp3);
  return temp20;
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetData_176(JNIEnv *env, jobject obj,jobject id0)
{
  vtkHyperTreeGrid *op;
  vtkInformation  *temp0;
  vtkHyperTreeGrid  *temp20;
  temp0 = (vtkInformation *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetData(temp0);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkHyperTreeGrid_GetData_177(JNIEnv *env, jobject obj,jobject id0,jint id1)
{
  vtkHyperTreeGrid *op;
  vtkInformationVector  *temp0;
  int      temp1;
  vtkHyperTreeGrid  *temp20;
  temp0 = (vtkInformationVector *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = id1;

  op = (vtkHyperTreeGrid *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetData(temp0,temp1);
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkHyperTreeGrid_VTKInit(JNIEnv *, jobject)
{
  vtkHyperTreeGrid *aNewOne = vtkHyperTreeGrid::New();
  return (jlong)(size_t)(void*)aNewOne;
}
