// java wrapper for vtkStructuredGridConnectivity object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkStructuredGridConnectivity.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkAbstractGridConnectivity_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkStructuredGridConnectivity_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkStructuredGridConnectivity",dType)) { return me; }
  if ((res= vtkAbstractGridConnectivity_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkStructuredGridConnectivity *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkStructuredGridConnectivity *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetWholeExtent_12(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2,jint id3,jint id4,jint id5)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  int      temp1;
  int      temp2;
  int      temp3;
  int      temp4;
  int      temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->SetWholeExtent(temp0,temp1,temp2,temp3,temp4,temp5);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetWholeExtent_13(JNIEnv *env, jobject obj,jintArray id0)
{
  vtkStructuredGridConnectivity *op;
  int    temp0[6];
  void *tempArray0;
  tempArray0 = (void *)(env->GetIntArrayElements(id0,nullptr));
  temp0[0] = ((jint *)tempArray0)[0];
  temp0[1] = ((jint *)tempArray0)[1];
  temp0[2] = ((jint *)tempArray0)[2];
  temp0[3] = ((jint *)tempArray0)[3];
  temp0[4] = ((jint *)tempArray0)[4];
  temp0[5] = ((jint *)tempArray0)[5];

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->SetWholeExtent(temp0);
  ((jint *)tempArray0)[0] = temp0[0];
  ((jint *)tempArray0)[1] = temp0[1];
  ((jint *)tempArray0)[2] = temp0[2];
  ((jint *)tempArray0)[3] = temp0[3];
  ((jint *)tempArray0)[4] = temp0[4];
  ((jint *)tempArray0)[5] = temp0[5];
  env->ReleaseIntArrayElements(id0,(jint *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetWholeExtent_14(JNIEnv *env, jobject obj)
{
  vtkStructuredGridConnectivity *op;
  int     *temp20;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetWholeExtent();
    return vtkJavaMakeJArrayOfIntFromInt(env,temp20,6);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetDataDimension_15(JNIEnv *env, jobject obj)
{
  vtkStructuredGridConnectivity *op;
  int      temp20;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDataDimension();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetNumberOfGrids_16(JNIEnv *env, jobject obj,jint id0)
{
  vtkStructuredGridConnectivity *op;
   unsigned int      temp0;
  temp0 = id0;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNumberOfGrids(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_RegisterGrid_17(JNIEnv *env, jobject obj,jint id0,jintArray id1,jobject id2,jobject id3,jobject id4,jobject id5,jobject id6)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  int    temp1[6];
  void *tempArray1;
  vtkUnsignedCharArray  *temp2;
  vtkUnsignedCharArray  *temp3;
  vtkPointData  *temp4;
  vtkCellData  *temp5;
  vtkPoints  *temp6;
  temp0 = id0;
  tempArray1 = (void *)(env->GetIntArrayElements(id1,nullptr));
  temp1[0] = ((jint *)tempArray1)[0];
  temp1[1] = ((jint *)tempArray1)[1];
  temp1[2] = ((jint *)tempArray1)[2];
  temp1[3] = ((jint *)tempArray1)[3];
  temp1[4] = ((jint *)tempArray1)[4];
  temp1[5] = ((jint *)tempArray1)[5];
  temp2 = (vtkUnsignedCharArray *)(vtkJavaGetPointerFromObject(env,id2));
  temp3 = (vtkUnsignedCharArray *)(vtkJavaGetPointerFromObject(env,id3));
  temp4 = (vtkPointData *)(vtkJavaGetPointerFromObject(env,id4));
  temp5 = (vtkCellData *)(vtkJavaGetPointerFromObject(env,id5));
  temp6 = (vtkPoints *)(vtkJavaGetPointerFromObject(env,id6));

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->RegisterGrid(temp0,temp1,temp2,temp3,temp4,temp5,temp6);
  ((jint *)tempArray1)[0] = temp1[0];
  ((jint *)tempArray1)[1] = temp1[1];
  ((jint *)tempArray1)[2] = temp1[2];
  ((jint *)tempArray1)[3] = temp1[3];
  ((jint *)tempArray1)[4] = temp1[4];
  ((jint *)tempArray1)[5] = temp1[5];
  env->ReleaseIntArrayElements(id1,(jint *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetGridExtent_18(JNIEnv *env, jobject obj,jint id0,jintArray id1)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  int    temp1[6];
  void *tempArray1;
  temp0 = id0;
  tempArray1 = (void *)(env->GetIntArrayElements(id1,nullptr));
  temp1[0] = ((jint *)tempArray1)[0];
  temp1[1] = ((jint *)tempArray1)[1];
  temp1[2] = ((jint *)tempArray1)[2];
  temp1[3] = ((jint *)tempArray1)[3];
  temp1[4] = ((jint *)tempArray1)[4];
  temp1[5] = ((jint *)tempArray1)[5];

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->GetGridExtent(temp0,temp1);
  ((jint *)tempArray1)[0] = temp1[0];
  ((jint *)tempArray1)[1] = temp1[1];
  ((jint *)tempArray1)[2] = temp1[2];
  ((jint *)tempArray1)[3] = temp1[3];
  ((jint *)tempArray1)[4] = temp1[4];
  ((jint *)tempArray1)[5] = temp1[5];
  env->ReleaseIntArrayElements(id1,(jint *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_SetGhostedGridExtent_19(JNIEnv *env, jobject obj,jint id0,jintArray id1)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  int    temp1[6];
  void *tempArray1;
  temp0 = id0;
  tempArray1 = (void *)(env->GetIntArrayElements(id1,nullptr));
  temp1[0] = ((jint *)tempArray1)[0];
  temp1[1] = ((jint *)tempArray1)[1];
  temp1[2] = ((jint *)tempArray1)[2];
  temp1[3] = ((jint *)tempArray1)[3];
  temp1[4] = ((jint *)tempArray1)[4];
  temp1[5] = ((jint *)tempArray1)[5];

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->SetGhostedGridExtent(temp0,temp1);
  ((jint *)tempArray1)[0] = temp1[0];
  ((jint *)tempArray1)[1] = temp1[1];
  ((jint *)tempArray1)[2] = temp1[2];
  ((jint *)tempArray1)[3] = temp1[3];
  ((jint *)tempArray1)[4] = temp1[4];
  ((jint *)tempArray1)[5] = temp1[5];
  env->ReleaseIntArrayElements(id1,(jint *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetGhostedGridExtent_110(JNIEnv *env, jobject obj,jint id0,jintArray id1)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  int    temp1[6];
  void *tempArray1;
  temp0 = id0;
  tempArray1 = (void *)(env->GetIntArrayElements(id1,nullptr));
  temp1[0] = ((jint *)tempArray1)[0];
  temp1[1] = ((jint *)tempArray1)[1];
  temp1[2] = ((jint *)tempArray1)[2];
  temp1[3] = ((jint *)tempArray1)[3];
  temp1[4] = ((jint *)tempArray1)[4];
  temp1[5] = ((jint *)tempArray1)[5];

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->GetGhostedGridExtent(temp0,temp1);
  ((jint *)tempArray1)[0] = temp1[0];
  ((jint *)tempArray1)[1] = temp1[1];
  ((jint *)tempArray1)[2] = temp1[2];
  ((jint *)tempArray1)[3] = temp1[3];
  ((jint *)tempArray1)[4] = temp1[4];
  ((jint *)tempArray1)[5] = temp1[5];
  env->ReleaseIntArrayElements(id1,(jint *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_ComputeNeighbors_111(JNIEnv *env, jobject obj)
{
  vtkStructuredGridConnectivity *op;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->ComputeNeighbors();
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkStructuredGridConnectivity_GetNumberOfNeighbors_112(JNIEnv *env, jobject obj,jint id0)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  int      temp20;
  temp0 = id0;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfNeighbors(temp0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_FillGhostArrays_113(JNIEnv *env, jobject obj,jint id0,jobject id1,jobject id2)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  vtkUnsignedCharArray  *temp1;
  vtkUnsignedCharArray  *temp2;
  temp0 = id0;
  temp1 = (vtkUnsignedCharArray *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkUnsignedCharArray *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->FillGhostArrays(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkStructuredGridConnectivity_CreateGhostLayers_114(JNIEnv *env, jobject obj,jint id0)
{
  vtkStructuredGridConnectivity *op;
  int      temp0;
  temp0 = id0;

  op = (vtkStructuredGridConnectivity *)vtkJavaGetPointerFromObject(env,obj);
  op->CreateGhostLayers(temp0);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkStructuredGridConnectivity_VTKInit(JNIEnv *, jobject)
{
  vtkStructuredGridConnectivity *aNewOne = vtkStructuredGridConnectivity::New();
  return (jlong)(size_t)(void*)aNewOne;
}
