// java wrapper for vtkEllipsoidalGaussianKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkEllipsoidalGaussianKernel.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkGeneralizedKernel_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkEllipsoidalGaussianKernel_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkEllipsoidalGaussianKernel",dType)) { return me; }
  if ((res= vtkGeneralizedKernel_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkEllipsoidalGaussianKernel *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkEllipsoidalGaussianKernel *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_Initialize_12(JNIEnv *env, jobject obj,jobject id0,jobject id1,jobject id2)
{
  vtkEllipsoidalGaussianKernel *op;
  vtkAbstractPointLocator  *temp0;
  vtkDataSet  *temp1;
  vtkPointData  *temp2;
  temp0 = (vtkAbstractPointLocator *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = (vtkDataSet *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkPointData *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->Initialize(temp0,temp1,temp2);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_ComputeWeights_13(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jobject id2,jobject id3)
{
  vtkEllipsoidalGaussianKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkDoubleArray  *temp2;
  vtkDoubleArray  *temp3;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id2));
  temp3 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id3));

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeWeights(temp0,temp1,temp2,temp3);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetUseNormals_14(JNIEnv *env, jobject obj,jboolean id0)
{
  vtkEllipsoidalGaussianKernel *op;
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUseNormals(temp0);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetUseNormals_15(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  bool   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetUseNormals();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseNormalsOn_16(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->UseNormalsOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseNormalsOff_17(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->UseNormalsOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetNormalsArrayName_18(JNIEnv *env, jobject obj,jstring id0)
{
  vtkEllipsoidalGaussianKernel *op;
  vtkStdString   temp0;
  vtkJavaUTFToString(env,id0,temp0);

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetNormalsArrayName(temp0);
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetNormalsArrayName_19(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  vtkStdString   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNormalsArrayName();
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetUseScalars_110(JNIEnv *env, jobject obj,jboolean id0)
{
  vtkEllipsoidalGaussianKernel *op;
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUseScalars(temp0);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetUseScalars_111(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  bool   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetUseScalars();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseScalarsOn_112(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->UseScalarsOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_UseScalarsOff_113(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->UseScalarsOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetScalarsArrayName_114(JNIEnv *env, jobject obj,jstring id0)
{
  vtkEllipsoidalGaussianKernel *op;
  vtkStdString   temp0;
  vtkJavaUTFToString(env,id0,temp0);

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetScalarsArrayName(temp0);
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScalarsArrayName_115(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  vtkStdString   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScalarsArrayName();
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetScaleFactor_116(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetScaleFactor(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScaleFactorMinValue_117(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScaleFactorMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScaleFactorMaxValue_118(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScaleFactorMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetScaleFactor_119(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetScaleFactor();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetSharpness_120(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSharpness(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetSharpnessMinValue_121(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSharpnessMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetSharpnessMaxValue_122(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSharpnessMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetSharpness_123(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSharpness();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_SetEccentricity_124(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  op->SetEccentricity(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetEccentricityMinValue_125(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetEccentricityMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetEccentricityMaxValue_126(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetEccentricityMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_GetEccentricity_127(JNIEnv *env, jobject obj)
{
  vtkEllipsoidalGaussianKernel *op;
  double   temp20;

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetEccentricity();
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_ComputeWeights_128(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  vtkEllipsoidalGaussianKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkDoubleArray  *temp2;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkEllipsoidalGaussianKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeWeights(temp0,temp1,temp2);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkEllipsoidalGaussianKernel_VTKInit(JNIEnv *, jobject)
{
  vtkEllipsoidalGaussianKernel *aNewOne = vtkEllipsoidalGaussianKernel::New();
  return (jlong)(size_t)(void*)aNewOne;
}
