// java wrapper for vtkUnsignedDistance object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkUnsignedDistance.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkImageAlgorithm_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkUnsignedDistance_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkUnsignedDistance",dType)) { return me; }
  if ((res= vtkImageAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkUnsignedDistance *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkUnsignedDistance *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkUnsignedDistance_GetDimensions_12(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  int     *temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDimensions();
    return vtkJavaMakeJArrayOfIntFromInt(env,temp20,3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetDimensions_13(JNIEnv *env, jobject obj,jint id0,jint id1,jint id2)
{
  vtkUnsignedDistance *op;
  int      temp0;
  int      temp1;
  int      temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetDimensions(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetDimensions_14(JNIEnv *env, jobject obj,jintArray id0)
{
  vtkUnsignedDistance *op;
  int    temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetIntArrayElements(id0,nullptr));
  temp0[0] = ((jint *)tempArray0)[0];
  temp0[1] = ((jint *)tempArray0)[1];
  temp0[2] = ((jint *)tempArray0)[2];

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetDimensions(temp0);
  ((jint *)tempArray0)[0] = temp0[0];
  ((jint *)tempArray0)[1] = temp0[1];
  ((jint *)tempArray0)[2] = temp0[2];
  env->ReleaseIntArrayElements(id0,(jint *)tempArray0,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetBounds_15(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2,jdouble id3,jdouble id4,jdouble id5)
{
  vtkUnsignedDistance *op;
  double   temp0;
  double   temp1;
  double   temp2;
  double   temp3;
  double   temp4;
  double   temp5;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;
  temp3 = id3;
  temp4 = id4;
  temp5 = id5;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBounds(temp0,temp1,temp2,temp3,temp4,temp5);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetBounds_16(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkUnsignedDistance *op;
  double temp0[6];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp0[3] = ((jdouble *)tempArray0)[3];
  temp0[4] = ((jdouble *)tempArray0)[4];
  temp0[5] = ((jdouble *)tempArray0)[5];

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetBounds(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  ((jdouble *)tempArray0)[3] = temp0[3];
  ((jdouble *)tempArray0)[4] = temp0[4];
  ((jdouble *)tempArray0)[5] = temp0[5];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkUnsignedDistance_GetBounds_17(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double  *temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBounds();
    return vtkJavaMakeJArrayOfDoubleFromDouble(env,temp20,6);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetAdjustBounds_18(JNIEnv *env, jobject obj,jint id0)
{
  vtkUnsignedDistance *op;
  int      temp0;
  temp0 = id0;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetAdjustBounds(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustBounds_19(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  int      temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAdjustBounds();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_AdjustBoundsOn_110(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->AdjustBoundsOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_AdjustBoundsOff_111(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->AdjustBoundsOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetAdjustDistance_112(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkUnsignedDistance *op;
  double   temp0;
  temp0 = id0;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetAdjustDistance(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustDistanceMinValue_113(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAdjustDistanceMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustDistanceMaxValue_114(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAdjustDistanceMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetAdjustDistance_115(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAdjustDistance();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetRadius_116(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkUnsignedDistance *op;
  double   temp0;
  temp0 = id0;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetRadius(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetRadiusMinValue_117(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadiusMinValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetRadiusMaxValue_118(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadiusMaxValue();
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetRadius_119(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetRadius();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetLocator_120(JNIEnv *env, jobject obj,jobject id0)
{
  vtkUnsignedDistance *op;
  vtkAbstractPointLocator  *temp0;
  temp0 = (vtkAbstractPointLocator *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetLocator(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkUnsignedDistance_GetLocator_121(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  vtkAbstractPointLocator  *temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetLocator();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetCapping_122(JNIEnv *env, jobject obj,jint id0)
{
  vtkUnsignedDistance *op;
  int      temp0;
  temp0 = id0;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetCapping(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_GetCapping_123(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  int      temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCapping();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_CappingOn_124(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->CappingOn();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_CappingOff_125(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->CappingOff();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetCapValue_126(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkUnsignedDistance *op;
  double   temp0;
  temp0 = id0;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetCapValue(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkUnsignedDistance_GetCapValue_127(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  double   temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCapValue();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetOutputScalarType_128(JNIEnv *env, jobject obj,jint id0)
{
  vtkUnsignedDistance *op;
  int      temp0;
  temp0 = id0;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOutputScalarType(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkUnsignedDistance_GetOutputScalarType_129(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;
  int      temp20;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetOutputScalarType();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetOutputScalarTypeToFloat_130(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOutputScalarTypeToFloat();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_SetOutputScalarTypeToDouble_131(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->SetOutputScalarTypeToDouble();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_StartAppend_132(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->StartAppend();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_Append_133(JNIEnv *env, jobject obj,jobject id0)
{
  vtkUnsignedDistance *op;
  vtkPolyData  *temp0;
  temp0 = (vtkPolyData *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->Append(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkUnsignedDistance_EndAppend_134(JNIEnv *env, jobject obj)
{
  vtkUnsignedDistance *op;

  op = (vtkUnsignedDistance *)vtkJavaGetPointerFromObject(env,obj);
  op->EndAppend();
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkUnsignedDistance_VTKInit(JNIEnv *, jobject)
{
  vtkUnsignedDistance *aNewOne = vtkUnsignedDistance::New();
  return (jlong)(size_t)(void*)aNewOne;
}
