// java wrapper for vtkVoronoiKernel object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkVoronoiKernel.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkInterpolationKernel_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkVoronoiKernel_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkVoronoiKernel",dType)) { return me; }
  if ((res= vtkInterpolationKernel_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoronoiKernel_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkVoronoiKernel *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkVoronoiKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoronoiKernel_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkVoronoiKernel *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkVoronoiKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoronoiKernel_ComputeBasis_12(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jint id2)
{
  vtkVoronoiKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkIdType   temp2;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = id2;

  op = (vtkVoronoiKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeBasis(temp0,temp1,temp2);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkVoronoiKernel_ComputeWeights_13(JNIEnv *env, jobject obj,jdoubleArray id0,jobject id1,jobject id2)
{
  vtkVoronoiKernel *op;
  double temp0[3];
  void *tempArray0;
  vtkIdList  *temp1;
  vtkDoubleArray  *temp2;
  vtkIdType   temp20;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];
  temp1 = (vtkIdList *)(vtkJavaGetPointerFromObject(env,id1));
  temp2 = (vtkDoubleArray *)(vtkJavaGetPointerFromObject(env,id2));

  op = (vtkVoronoiKernel *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->ComputeWeights(temp0,temp1,temp2);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
  return temp20;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkVoronoiKernel_VTKInit(JNIEnv *, jobject)
{
  vtkVoronoiKernel *aNewOne = vtkVoronoiKernel::New();
  return (jlong)(size_t)(void*)aNewOne;
}
