// java wrapper for vtkPeriodicTable object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkPeriodicTable.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkPeriodicTable_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkPeriodicTable",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPeriodicTable_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkPeriodicTable *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPeriodicTable_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkPeriodicTable *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkPeriodicTable_GetBlueObeliskData_12(JNIEnv *env, jobject obj)
{
  vtkPeriodicTable *op;
  vtkBlueObeliskData  *temp20;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetBlueObeliskData();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPeriodicTable_GetNumberOfElements_13(JNIEnv *env, jobject obj)
{
  vtkPeriodicTable *op;
   unsigned short    temp20;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetNumberOfElements();
  return temp20;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkPeriodicTable_GetSymbol_14(JNIEnv *env, jobject obj,jint id0)
{
  vtkPeriodicTable *op;
   unsigned short    temp0;
  const char    *temp20;
  temp0 = id0;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSymbol(temp0);
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkPeriodicTable_GetElementName_15(JNIEnv *env, jobject obj,jint id0)
{
  vtkPeriodicTable *op;
   unsigned short    temp0;
  const char    *temp20;
  temp0 = id0;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetElementName(temp0);
  return vtkJavaMakeJavaString(env,temp20);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkPeriodicTable_GetAtomicNumber_16(JNIEnv *env, jobject obj,jstring id0)
{
  vtkPeriodicTable *op;
  vtkStdString temp0;
   unsigned short    temp20;
  vtkJavaUTFToString(env,id0,temp0);

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetAtomicNumber(temp0);
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkPeriodicTable_GetCovalentRadius_17(JNIEnv *env, jobject obj,jint id0)
{
  vtkPeriodicTable *op;
   unsigned short    temp0;
  float    temp20;
  temp0 = id0;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetCovalentRadius(temp0);
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkPeriodicTable_GetVDWRadius_18(JNIEnv *env, jobject obj,jint id0)
{
  vtkPeriodicTable *op;
   unsigned short    temp0;
  float    temp20;
  temp0 = id0;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetVDWRadius(temp0);
  return temp20;
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkPeriodicTable_GetMaxVDWRadius_19(JNIEnv *env, jobject obj)
{
  vtkPeriodicTable *op;
  float    temp20;

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaxVDWRadius();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPeriodicTable_GetDefaultLUT_110(JNIEnv *env, jobject obj,jobject id0)
{
  vtkPeriodicTable *op;
  vtkLookupTable  *temp0;
  temp0 = (vtkLookupTable *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  op->GetDefaultLUT(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkPeriodicTable_GetDefaultRGBTuple_111(JNIEnv *env, jobject obj,jint id0,jdoubleArray id1)
{
  vtkPeriodicTable *op;
   unsigned short    temp0;
  float  temp1[3];
  void *tempArray1;
  temp0 = id0;
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];
  temp1[2] = ((jdouble *)tempArray1)[2];

  op = (vtkPeriodicTable *)vtkJavaGetPointerFromObject(env,obj);
  op->GetDefaultRGBTuple(temp0,temp1);
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  ((jdouble *)tempArray1)[2] = temp1[2];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkPeriodicTable_VTKInit(JNIEnv *, jobject)
{
  vtkPeriodicTable *aNewOne = vtkPeriodicTable::New();
  return (jlong)(size_t)(void*)aNewOne;
}
