// java wrapper for vtkEvenlySpacedStreamlines2D object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkEvenlySpacedStreamlines2D.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkPolyDataAlgorithm_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkEvenlySpacedStreamlines2D_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkEvenlySpacedStreamlines2D",dType)) { return me; }
  if ((res= vtkPolyDataAlgorithm_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetStartPosition_12(JNIEnv *env, jobject obj,jdouble id0,jdouble id1,jdouble id2)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  double   temp1;
  double   temp2;
  temp0 = id0;
  temp1 = id1;
  temp2 = id2;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetStartPosition(temp0,temp1,temp2);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetStartPosition_13(JNIEnv *env, jobject obj,jdoubleArray id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double temp0[3];
  void *tempArray0;
  tempArray0 = (void *)(env->GetDoubleArrayElements(id0,nullptr));
  temp0[0] = ((jdouble *)tempArray0)[0];
  temp0[1] = ((jdouble *)tempArray0)[1];
  temp0[2] = ((jdouble *)tempArray0)[2];

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetStartPosition(temp0);
  ((jdouble *)tempArray0)[0] = temp0[0];
  ((jdouble *)tempArray0)[1] = temp0[1];
  ((jdouble *)tempArray0)[2] = temp0[2];
  env->ReleaseDoubleArrayElements(id0,(jdouble *)tempArray0,0);
}

extern "C" JNIEXPORT jarray  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetStartPosition_14(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double  *temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetStartPosition();
    return vtkJavaMakeJArrayOfDoubleFromDouble(env,temp20,3);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegrator_15(JNIEnv *env, jobject obj,jobject id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkInitialValueProblemSolver  *temp0;
  temp0 = (vtkInitialValueProblemSolver *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIntegrator(temp0);
}

extern "C" JNIEXPORT jlong  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetIntegrator_16(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkInitialValueProblemSolver  *temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetIntegrator();
  return (jlong)(size_t)temp20;}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegratorType_17(JNIEnv *env, jobject obj,jint id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  int      temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIntegratorType(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetIntegratorType_18(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  int      temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetIntegratorType();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegratorTypeToRungeKutta2_19(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIntegratorTypeToRungeKutta2();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegratorTypeToRungeKutta4_110(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIntegratorTypeToRungeKutta4();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorTypeToDataSetPointLocator_111(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInterpolatorTypeToDataSetPointLocator();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorTypeToCellLocator_112(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInterpolatorTypeToCellLocator();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetIntegrationStepUnit_113(JNIEnv *env, jobject obj,jint id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  int      temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetIntegrationStepUnit(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetIntegrationStepUnit_114(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  int      temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetIntegrationStepUnit();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetMaximumNumberOfSteps_115(JNIEnv *env, jobject obj,jint id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkIdType   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetMaximumNumberOfSteps(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetMaximumNumberOfSteps_116(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkIdType   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMaximumNumberOfSteps();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetMinimumNumberOfLoopPoints_117(JNIEnv *env, jobject obj,jint id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkIdType   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetMinimumNumberOfLoopPoints(temp0);
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetMinimumNumberOfLoopPoints_118(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkIdType   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetMinimumNumberOfLoopPoints();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInitialIntegrationStep_119(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInitialIntegrationStep(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetInitialIntegrationStep_120(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetInitialIntegrationStep();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetSeparatingDistance_121(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSeparatingDistance(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetSeparatingDistance_122(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSeparatingDistance();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetSeparatingDistanceRatio_123(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetSeparatingDistanceRatio(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetSeparatingDistanceRatio_124(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetSeparatingDistanceRatio();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetClosedLoopMaximumDistance_125(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetClosedLoopMaximumDistance(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetClosedLoopMaximumDistance_126(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetClosedLoopMaximumDistance();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetLoopAngle_127(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetLoopAngle(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetLoopAngle_128(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetLoopAngle();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetTerminalSpeed_129(JNIEnv *env, jobject obj,jdouble id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetTerminalSpeed(temp0);
}

extern "C" JNIEXPORT jdouble  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetTerminalSpeed_130(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  double   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetTerminalSpeed();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetComputeVorticity_131(JNIEnv *env, jobject obj,jboolean id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  bool   temp0;
  temp0 = (id0 != 0) ? true : false;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetComputeVorticity(temp0);
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_GetComputeVorticity_132(JNIEnv *env, jobject obj)
{
  vtkEvenlySpacedStreamlines2D *op;
  bool   temp20;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetComputeVorticity();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorPrototype_133(JNIEnv *env, jobject obj,jobject id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  vtkAbstractInterpolatedVelocityField  *temp0;
  temp0 = (vtkAbstractInterpolatedVelocityField *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInterpolatorPrototype(temp0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_SetInterpolatorType_134(JNIEnv *env, jobject obj,jint id0)
{
  vtkEvenlySpacedStreamlines2D *op;
  int      temp0;
  temp0 = id0;

  op = (vtkEvenlySpacedStreamlines2D *)vtkJavaGetPointerFromObject(env,obj);
  op->SetInterpolatorType(temp0);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkEvenlySpacedStreamlines2D_VTKInit(JNIEnv *, jobject)
{
  vtkEvenlySpacedStreamlines2D *aNewOne = vtkEvenlySpacedStreamlines2D::New();
  return (jlong)(size_t)(void*)aNewOne;
}
