// java wrapper for vtkSMPTransform object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkSMPTransform.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkTransform_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkSMPTransform_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkSMPTransform",dType)) { return me; }
  if ((res= vtkTransform_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSMPTransform_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkSMPTransform *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkSMPTransform *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkSMPTransform_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkSMPTransform *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkSMPTransform *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSMPTransform_TransformPoints_12(JNIEnv *env, jobject obj,jobject id0,jobject id1)
{
  vtkSMPTransform *op;
  vtkPoints  *temp0;
  vtkPoints  *temp1;
  temp0 = (vtkPoints *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = (vtkPoints *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkSMPTransform *)vtkJavaGetPointerFromObject(env,obj);
  op->TransformPoints(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSMPTransform_TransformNormals_13(JNIEnv *env, jobject obj,jobject id0,jobject id1)
{
  vtkSMPTransform *op;
  vtkDataArray  *temp0;
  vtkDataArray  *temp1;
  temp0 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkSMPTransform *)vtkJavaGetPointerFromObject(env,obj);
  op->TransformNormals(temp0,temp1);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkSMPTransform_TransformVectors_14(JNIEnv *env, jobject obj,jobject id0,jobject id1)
{
  vtkSMPTransform *op;
  vtkDataArray  *temp0;
  vtkDataArray  *temp1;
  temp0 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id0));
  temp1 = (vtkDataArray *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkSMPTransform *)vtkJavaGetPointerFromObject(env,obj);
  op->TransformVectors(temp0,temp1);
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkSMPTransform_VTKInit(JNIEnv *, jobject)
{
  vtkSMPTransform *aNewOne = vtkSMPTransform::New();
  return (jlong)(size_t)(void*)aNewOne;
}
