// java wrapper for vtkOpenGLUniforms object
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkSystemIncludes.h"
#include "vtkOpenGLUniforms.h"
#include "vtkJavaUtil.h"

#include "vtkStdString.h"

#include <sstream>
extern "C" JNIEXPORT void* vtkObject_Typecast(void *op,char *dType);

extern "C" JNIEXPORT void* vtkOpenGLUniforms_Typecast(void *me,char *dType)
{
  void* res;
  if (!strcmp("vtkOpenGLUniforms",dType)) { return me; }
  if ((res= vtkObject_Typecast(me,dType)) != nullptr) { return res; }
  return nullptr;
}


extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLUniforms_IsTypeOf_10(JNIEnv *env, jobject obj,jstring id0)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsTypeOf(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLUniforms_IsA_11(JNIEnv *env, jobject obj,jstring id0)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  int      temp20;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->IsA(temp0);
  delete[] temp0;
  return temp20;
}

extern "C" JNIEXPORT jstring  JNICALL Java_vtk_vtkOpenGLUniforms_GetDeclarations_12(JNIEnv *env, jobject obj)
{
  vtkOpenGLUniforms *op;
  std::string   temp20;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetDeclarations();
  return vtkJavaMakeJavaString(env,temp20.c_str());
}

extern "C" JNIEXPORT jboolean  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniforms_13(JNIEnv *env, jobject obj,jobject id0)
{
  vtkOpenGLUniforms *op;
  vtkShaderProgram  *temp0;
  bool   temp20;
  temp0 = (vtkShaderProgram *)(vtkJavaGetPointerFromObject(env,id0));

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->SetUniforms(temp0);
  return temp20;
}

extern "C" JNIEXPORT jint  JNICALL Java_vtk_vtkOpenGLUniforms_GetUniformListMTime_14(JNIEnv *env, jobject obj)
{
  vtkOpenGLUniforms *op;
   unsigned long     temp20;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  temp20 = (op)->GetUniformListMTime();
  return temp20;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniformi_15(JNIEnv *env, jobject obj,jstring id0,jint id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  int      temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = id1;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniformi(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniformf_16(JNIEnv *env, jobject obj,jstring id0,jdouble id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float    temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = id1;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniformf(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniform2i_17(JNIEnv *env, jobject obj,jstring id0,jintArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  int    temp1[2];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetIntArrayElements(id1,nullptr));
  temp1[0] = ((jint *)tempArray1)[0];
  temp1[1] = ((jint *)tempArray1)[1];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniform2i(temp0,temp1);
  delete[] temp0;
  ((jint *)tempArray1)[0] = temp1[0];
  ((jint *)tempArray1)[1] = temp1[1];
  env->ReleaseIntArrayElements(id1,(jint *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniform2f_18(JNIEnv *env, jobject obj,jstring id0,jdoubleArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float  temp1[2];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniform2f(temp0,temp1);
  delete[] temp0;
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniform3f_19(JNIEnv *env, jobject obj,jstring id0,jdoubleArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float  temp1[3];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];
  temp1[2] = ((jdouble *)tempArray1)[2];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniform3f(temp0,temp1);
  delete[] temp0;
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  ((jdouble *)tempArray1)[2] = temp1[2];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniform4f_110(JNIEnv *env, jobject obj,jstring id0,jdoubleArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float  temp1[4];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];
  temp1[2] = ((jdouble *)tempArray1)[2];
  temp1[3] = ((jdouble *)tempArray1)[3];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniform4f(temp0,temp1);
  delete[] temp0;
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  ((jdouble *)tempArray1)[2] = temp1[2];
  ((jdouble *)tempArray1)[3] = temp1[3];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniformMatrix_111(JNIEnv *env, jobject obj,jstring id0,jobject id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  vtkMatrix3x3  *temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = (vtkMatrix3x3 *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniformMatrix(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_AddUniformMatrix_112(JNIEnv *env, jobject obj,jstring id0,jobject id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  vtkMatrix4x4  *temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = (vtkMatrix4x4 *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->AddUniformMatrix(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_RemoveUniform_113(JNIEnv *env, jobject obj,jstring id0)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  temp0 = vtkJavaUTFToChar(env,id0);

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->RemoveUniform(temp0);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_RemoveAllUniforms_114(JNIEnv *env, jobject obj)
{
  vtkOpenGLUniforms *op;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->RemoveAllUniforms();
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniformi_115(JNIEnv *env, jobject obj,jstring id0,jint id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  int      temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = id1;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniformi(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniformf_116(JNIEnv *env, jobject obj,jstring id0,jdouble id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float    temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = id1;

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniformf(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniform2i_117(JNIEnv *env, jobject obj,jstring id0,jintArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  int    temp1[2];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetIntArrayElements(id1,nullptr));
  temp1[0] = ((jint *)tempArray1)[0];
  temp1[1] = ((jint *)tempArray1)[1];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniform2i(temp0,temp1);
  delete[] temp0;
  ((jint *)tempArray1)[0] = temp1[0];
  ((jint *)tempArray1)[1] = temp1[1];
  env->ReleaseIntArrayElements(id1,(jint *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniform2f_118(JNIEnv *env, jobject obj,jstring id0,jdoubleArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float  temp1[2];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniform2f(temp0,temp1);
  delete[] temp0;
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniform3f_119(JNIEnv *env, jobject obj,jstring id0,jdoubleArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float  temp1[3];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];
  temp1[2] = ((jdouble *)tempArray1)[2];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniform3f(temp0,temp1);
  delete[] temp0;
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  ((jdouble *)tempArray1)[2] = temp1[2];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniform4f_120(JNIEnv *env, jobject obj,jstring id0,jdoubleArray id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  float  temp1[4];
  void *tempArray1;
  temp0 = vtkJavaUTFToChar(env,id0);
  tempArray1 = (void *)(env->GetDoubleArrayElements(id1,nullptr));
  temp1[0] = ((jdouble *)tempArray1)[0];
  temp1[1] = ((jdouble *)tempArray1)[1];
  temp1[2] = ((jdouble *)tempArray1)[2];
  temp1[3] = ((jdouble *)tempArray1)[3];

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniform4f(temp0,temp1);
  delete[] temp0;
  ((jdouble *)tempArray1)[0] = temp1[0];
  ((jdouble *)tempArray1)[1] = temp1[1];
  ((jdouble *)tempArray1)[2] = temp1[2];
  ((jdouble *)tempArray1)[3] = temp1[3];
  env->ReleaseDoubleArrayElements(id1,(jdouble *)tempArray1,0);
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniformMatrix_121(JNIEnv *env, jobject obj,jstring id0,jobject id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  vtkMatrix3x3  *temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = (vtkMatrix3x3 *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniformMatrix(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT void  JNICALL Java_vtk_vtkOpenGLUniforms_SetUniformMatrix_122(JNIEnv *env, jobject obj,jstring id0,jobject id1)
{
  vtkOpenGLUniforms *op;
  char    *temp0;
  vtkMatrix4x4  *temp1;
  temp0 = vtkJavaUTFToChar(env,id0);
  temp1 = (vtkMatrix4x4 *)(vtkJavaGetPointerFromObject(env,id1));

  op = (vtkOpenGLUniforms *)vtkJavaGetPointerFromObject(env,obj);
  op->SetUniformMatrix(temp0,temp1);
  delete[] temp0;
}

extern "C" JNIEXPORT jlong JNICALL Java_vtk_vtkOpenGLUniforms_VTKInit(JNIEnv *, jobject)
{
  vtkOpenGLUniforms *aNewOne = vtkOpenGLUniforms::New();
  return (jlong)(size_t)(void*)aNewOne;
}
