// python wrapper for vtkGeoAdaptiveArcs
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoAdaptiveArcs.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoAdaptiveArcs(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoAdaptiveArcs_ClassNew(); }

#ifndef DECLARED_PyvtkPolyDataAlgorithm_ClassNew
extern "C" { PyObject *PyvtkPolyDataAlgorithm_ClassNew(); }
#define DECLARED_PyvtkPolyDataAlgorithm_ClassNew
#endif

static const char *PyvtkGeoAdaptiveArcs_Doc =
  "vtkGeoAdaptiveArcs - no description provided.\n\n"
  "Superclass: vtkPolyDataAlgorithm\n\n"
;


static PyObject *
PyvtkGeoAdaptiveArcs_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGeoAdaptiveArcs::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoAdaptiveArcs::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGeoAdaptiveArcs *tempr = vtkGeoAdaptiveArcs::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoAdaptiveArcs *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoAdaptiveArcs::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_SetGlobeRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetGlobeRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetGlobeRadius(temp0);
    }
    else
    {
      op->vtkGeoAdaptiveArcs::SetGlobeRadius(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_GetGlobeRadius(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetGlobeRadius");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetGlobeRadius() :
      op->vtkGeoAdaptiveArcs::GetGlobeRadius());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_SetMaximumPixelSeparation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMaximumPixelSeparation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMaximumPixelSeparation(temp0);
    }
    else
    {
      op->vtkGeoAdaptiveArcs::SetMaximumPixelSeparation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_GetMaximumPixelSeparation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMaximumPixelSeparation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMaximumPixelSeparation() :
      op->vtkGeoAdaptiveArcs::GetMaximumPixelSeparation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_SetMinimumPixelSeparation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetMinimumPixelSeparation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  double temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetMinimumPixelSeparation(temp0);
    }
    else
    {
      op->vtkGeoAdaptiveArcs::SetMinimumPixelSeparation(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_GetMinimumPixelSeparation(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMinimumPixelSeparation");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double tempr = (ap.IsBound() ?
      op->GetMinimumPixelSeparation() :
      op->vtkGeoAdaptiveArcs::GetMinimumPixelSeparation());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_SetRenderer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetRenderer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  vtkRenderer *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkRenderer"))
  {
    if (ap.IsBound())
    {
      op->SetRenderer(temp0);
    }
    else
    {
      op->vtkGeoAdaptiveArcs::SetRenderer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_GetRenderer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetRenderer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkRenderer *tempr = (ap.IsBound() ?
      op->GetRenderer() :
      op->vtkGeoAdaptiveArcs::GetRenderer());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoAdaptiveArcs_GetMTime(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetMTime");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoAdaptiveArcs *op = static_cast<vtkGeoAdaptiveArcs *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetMTime() :
      op->vtkGeoAdaptiveArcs::GetMTime());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoAdaptiveArcs_Methods[] = {
  {"IsTypeOf", PyvtkGeoAdaptiveArcs_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGeoAdaptiveArcs_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGeoAdaptiveArcs_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGeoAdaptiveArcs\nC++: static vtkGeoAdaptiveArcs *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGeoAdaptiveArcs_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoAdaptiveArcs\nC++: vtkGeoAdaptiveArcs *NewInstance()\n\n"},
  {"SetGlobeRadius", PyvtkGeoAdaptiveArcs_SetGlobeRadius, METH_VARARGS,
   "V.SetGlobeRadius(float)\nC++: virtual void SetGlobeRadius(double _arg)\n\nThe base radius used to determine the earth's surface. Default is\nthe earth's radius in meters. TODO: Change this to take in a\nvtkGeoTerrain to get altitude.\n"},
  {"GetGlobeRadius", PyvtkGeoAdaptiveArcs_GetGlobeRadius, METH_VARARGS,
   "V.GetGlobeRadius() -> float\nC++: virtual double GetGlobeRadius()\n\nThe base radius used to determine the earth's surface. Default is\nthe earth's radius in meters. TODO: Change this to take in a\nvtkGeoTerrain to get altitude.\n"},
  {"SetMaximumPixelSeparation", PyvtkGeoAdaptiveArcs_SetMaximumPixelSeparation, METH_VARARGS,
   "V.SetMaximumPixelSeparation(float)\nC++: virtual void SetMaximumPixelSeparation(double _arg)\n\nThe maximum number of pixels between points on the arcs. If two\nadjacent points are farther than the threshold, the line segment\nwill be subdivided such that each point is separated by at most\nthe threshold.\n"},
  {"GetMaximumPixelSeparation", PyvtkGeoAdaptiveArcs_GetMaximumPixelSeparation, METH_VARARGS,
   "V.GetMaximumPixelSeparation() -> float\nC++: virtual double GetMaximumPixelSeparation()\n\nThe maximum number of pixels between points on the arcs. If two\nadjacent points are farther than the threshold, the line segment\nwill be subdivided such that each point is separated by at most\nthe threshold.\n"},
  {"SetMinimumPixelSeparation", PyvtkGeoAdaptiveArcs_SetMinimumPixelSeparation, METH_VARARGS,
   "V.SetMinimumPixelSeparation(float)\nC++: virtual void SetMinimumPixelSeparation(double _arg)\n\nThe minimum number of pixels between points on the arcs. Points\ncloser than the threshold will be skipped until a point farther\nthan the minimum threshold is reached.\n"},
  {"GetMinimumPixelSeparation", PyvtkGeoAdaptiveArcs_GetMinimumPixelSeparation, METH_VARARGS,
   "V.GetMinimumPixelSeparation() -> float\nC++: virtual double GetMinimumPixelSeparation()\n\nThe minimum number of pixels between points on the arcs. Points\ncloser than the threshold will be skipped until a point farther\nthan the minimum threshold is reached.\n"},
  {"SetRenderer", PyvtkGeoAdaptiveArcs_SetRenderer, METH_VARARGS,
   "V.SetRenderer(vtkRenderer)\nC++: virtual void SetRenderer(vtkRenderer *ren)\n\nThe renderer used to estimate the number of pixels between\npoints.\n"},
  {"GetRenderer", PyvtkGeoAdaptiveArcs_GetRenderer, METH_VARARGS,
   "V.GetRenderer() -> vtkRenderer\nC++: virtual vtkRenderer *GetRenderer()\n\nThe renderer used to estimate the number of pixels between\npoints.\n"},
  {"GetMTime", PyvtkGeoAdaptiveArcs_GetMTime, METH_VARARGS,
   "V.GetMTime() -> int\nC++: vtkMTimeType GetMTime() override;\n\nReturn the modified time of this object.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGeoAdaptiveArcs_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoAdaptiveArcs", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGeoAdaptiveArcs_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoAdaptiveArcs_StaticNew()
{
  return vtkGeoAdaptiveArcs::New();
}

PyObject *PyvtkGeoAdaptiveArcs_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoAdaptiveArcs_Type, PyvtkGeoAdaptiveArcs_Methods,
    "vtkGeoAdaptiveArcs",
 &PyvtkGeoAdaptiveArcs_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoAdaptiveArcs_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkPolyDataAlgorithm_ClassNew();

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGeoAdaptiveArcs(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoAdaptiveArcs_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoAdaptiveArcs", o) != 0)
  {
    Py_DECREF(o);
  }

}

