// python wrapper for vtkGeoTreeNode
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include "vtkConfigure.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkIndent.h"
#include "vtkGeoTreeNode.h"

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkGeoTreeNode(PyObject *); }
extern "C" { VTK_ABI_EXPORT PyObject *PyvtkGeoTreeNode_ClassNew(); }

#ifndef DECLARED_PyvtkObject_ClassNew
extern "C" { PyObject *PyvtkObject_ClassNew(); }
#define DECLARED_PyvtkObject_ClassNew
#endif

static const char *PyvtkGeoTreeNode_Doc =
  "vtkGeoTreeNode - Stores data for a patch of the globe.\n\n"
  "Superclass: vtkObject\n\n"
  "A self-referential data structure for storing geometry or imagery for\n"
  "the geospatial views. The data is organized in a quadtree. Each node\n"
  "contains a pointer to its parent and owns references to its four\n"
  "child nodes. The ID of each node is unique in its level, and encodes\n"
  "the path from the root node in its bits.\n\n"
  "@sa\n"
  "vtkGeoView vtkGeoView2D vtkGeoTerrain\n"
  "vtkGeoAlignedImageRepresentation\n\n";

static PyTypeObject PyvtkGeoTreeNode_NodeStatus_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoTreeNode.NodeStatus", // tp_name
  sizeof(PyIntObject), // tp_basicsize
  0, // tp_itemsize
  nullptr, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  nullptr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  nullptr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  nullptr, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  &PyInt_Type, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  nullptr, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

PyObject *PyvtkGeoTreeNode_NodeStatus_FromEnum(int val)
{
#ifdef VTK_PY3K
  PyObject *args = Py_BuildValue("(i)", val);
  PyObject *obj = PyLong_Type.tp_new(&PyvtkGeoTreeNode_NodeStatus_Type, args, nullptr);
  Py_DECREF(args);
  return obj;
#else
  PyIntObject *self = PyObject_New(PyIntObject,
    &PyvtkGeoTreeNode_NodeStatus_Type);
  self->ob_ival = val;
  return (PyObject *)self;
#endif
}


static PyObject *
PyvtkGeoTreeNode_IsTypeOf(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "IsTypeOf");

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = vtkGeoTreeNode::IsTypeOf(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_IsA(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsA");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  const char *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    int tempr = (ap.IsBound() ?
      op->IsA(temp0) :
      op->vtkGeoTreeNode::IsA(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SafeDownCast(PyObject *, PyObject *args)
{
  vtkPythonArgs ap(args, "SafeDownCast");

  vtkObjectBase *temp0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkObjectBase"))
  {
    vtkGeoTreeNode *tempr = vtkGeoTreeNode::SafeDownCast(temp0);

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_NewInstance(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "NewInstance");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTreeNode *tempr = (ap.IsBound() ?
      op->NewInstance() :
      op->vtkGeoTreeNode::NewInstance());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
      if (result && PyVTKObject_Check(result))
      {
        PyVTKObject_GetObject(result)->UnRegister(0);
        PyVTKObject_SetFlag(result, VTK_PYTHON_IGNORE_UNREGISTER, 1);
      }
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  unsigned long temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetId(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetId(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetId(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetId");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    unsigned long tempr = (ap.IsBound() ?
      op->GetId() :
      op->vtkGeoTreeNode::GetId());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    if (ap.IsBound())
    {
      op->SetLevel(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetLevel(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetLevel(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLevel");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetLevel() :
      op->vtkGeoTreeNode::GetLevel());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetLongitudeRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLongitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  double temp0;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetLongitudeRange(temp0, temp1);
    }
    else
    {
      op->vtkGeoTreeNode::SetLongitudeRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGeoTreeNode_SetLongitudeRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLongitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  const size_t size0 = 2;
  double temp0[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetLongitudeRange(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetLongitudeRange(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGeoTreeNode_SetLongitudeRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkGeoTreeNode_SetLongitudeRange_s1(self, args);
    case 1:
      return PyvtkGeoTreeNode_SetLongitudeRange_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetLongitudeRange");
  return nullptr;
}



static PyObject *
PyvtkGeoTreeNode_GetLongitudeRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLongitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  size_t sizer = 2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetLongitudeRange() :
      op->vtkGeoTreeNode::GetLongitudeRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetLatitudeRange_s1(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLatitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  double temp0;
  double temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetValue(temp0) &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetLatitudeRange(temp0, temp1);
    }
    else
    {
      op->vtkGeoTreeNode::SetLatitudeRange(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGeoTreeNode_SetLatitudeRange_s2(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetLatitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  const size_t size0 = 2;
  double temp0[2];
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetArray(temp0, size0))
  {
    if (ap.IsBound())
    {
      op->SetLatitudeRange(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetLatitudeRange(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyObject *
PyvtkGeoTreeNode_SetLatitudeRange(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(self, args);

  switch(nargs)
  {
    case 2:
      return PyvtkGeoTreeNode_SetLatitudeRange_s1(self, args);
    case 1:
      return PyvtkGeoTreeNode_SetLatitudeRange_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "SetLatitudeRange");
  return nullptr;
}



static PyObject *
PyvtkGeoTreeNode_GetLatitudeRange(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetLatitudeRange");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  size_t sizer = 2;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    double *tempr = (ap.IsBound() ?
      op->GetLatitudeRange() :
      op->vtkGeoTreeNode::GetLatitudeRange());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildTuple(tempr, sizer);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetChild(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetChild");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  int temp1;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(2) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode") &&
      ap.GetValue(temp1))
  {
    if (ap.IsBound())
    {
      op->SetChild(temp0, temp1);
    }
    else
    {
      op->vtkGeoTreeNode::SetChild(temp0, temp1);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetParent(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetParent");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->SetParent(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetParent(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetOlder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetOlder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->SetOlder(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetOlder(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetOlder(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetOlder");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTreeNode *tempr = (ap.IsBound() ?
      op->GetOlder() :
      op->vtkGeoTreeNode::GetOlder());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetNewer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetNewer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->SetNewer(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetNewer(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetNewer(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetNewer");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTreeNode *tempr = (ap.IsBound() ?
      op->GetNewer() :
      op->vtkGeoTreeNode::GetNewer());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_HasData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "HasData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    bool tempr = (ap.IsBound() ?
      op->HasData() :
      op->vtkGeoTreeNode::HasData());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_DeleteData(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeleteData");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    if (ap.IsBound())
    {
      op->DeleteData();
    }
    else
    {
      op->vtkGeoTreeNode::DeleteData();
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetWhichChildAreYou(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetWhichChildAreYou");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->GetWhichChildAreYou() :
      op->vtkGeoTreeNode::GetWhichChildAreYou());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_IsDescendantOf(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "IsDescendantOf");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    bool tempr = (ap.IsBound() ?
      op->IsDescendantOf(temp0) :
      op->vtkGeoTreeNode::IsDescendantOf(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_CreateChildren(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "CreateChildren");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    int tempr = (ap.IsBound() ?
      op->CreateChildren() :
      op->vtkGeoTreeNode::CreateChildren());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildValue(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetChildTreeNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetChildTreeNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  int temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetValue(temp0))
  {
    vtkGeoTreeNode *tempr = (ap.IsBound() ?
      op->GetChildTreeNode(temp0) :
      op->vtkGeoTreeNode::GetChildTreeNode(temp0));

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetParentTreeNode(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetParentTreeNode");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    vtkGeoTreeNode *tempr = (ap.IsBound() ?
      op->GetParentTreeNode() :
      op->vtkGeoTreeNode::GetParentTreeNode());

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildVTKObject(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_GetStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "GetStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(0))
  {
    typedef vtkGeoTreeNode::NodeStatus tempr_type;
  tempr_type tempr = (ap.IsBound() ?
      op->GetStatus() :
      op->vtkGeoTreeNode::GetStatus());

    if (!ap.ErrorOccurred())
    {
      result = PyvtkGeoTreeNode_NodeStatus_FromEnum(tempr);
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_SetStatus(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "SetStatus");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  typedef vtkGeoTreeNode::NodeStatus temp0_type;
  temp0_type temp0;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetEnumValue(temp0, "vtkGeoTreeNode.NodeStatus"))
  {
    if (ap.IsBound())
    {
      op->SetStatus(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::SetStatus(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_ShallowCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "ShallowCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->ShallowCopy(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::ShallowCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}


static PyObject *
PyvtkGeoTreeNode_DeepCopy(PyObject *self, PyObject *args)
{
  vtkPythonArgs ap(self, args, "DeepCopy");
  vtkObjectBase *vp = ap.GetSelfPointer(self, args);
  vtkGeoTreeNode *op = static_cast<vtkGeoTreeNode *>(vp);

  vtkGeoTreeNode *temp0 = nullptr;
  PyObject *result = nullptr;

  if (op && ap.CheckArgCount(1) &&
      ap.GetVTKObject(temp0, "vtkGeoTreeNode"))
  {
    if (ap.IsBound())
    {
      op->DeepCopy(temp0);
    }
    else
    {
      op->vtkGeoTreeNode::DeepCopy(temp0);
    }

    if (!ap.ErrorOccurred())
    {
      result = ap.BuildNone();
    }
  }

  return result;
}

static PyMethodDef PyvtkGeoTreeNode_Methods[] = {
  {"IsTypeOf", PyvtkGeoTreeNode_IsTypeOf, METH_VARARGS,
   "V.IsTypeOf(string) -> int\nC++: static vtkTypeBool IsTypeOf(const char *type)\n\nReturn 1 if this class type is the same type of (or a subclass\nof) the named class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"IsA", PyvtkGeoTreeNode_IsA, METH_VARARGS,
   "V.IsA(string) -> int\nC++: vtkTypeBool IsA(const char *type) override;\n\nReturn 1 if this class is the same type of (or a subclass of) the\nnamed class. Returns 0 otherwise. This method works in\ncombination with vtkTypeMacro found in vtkSetGet.h.\n"},
  {"SafeDownCast", PyvtkGeoTreeNode_SafeDownCast, METH_VARARGS,
   "V.SafeDownCast(vtkObjectBase) -> vtkGeoTreeNode\nC++: static vtkGeoTreeNode *SafeDownCast(vtkObjectBase *o)\n\n"},
  {"NewInstance", PyvtkGeoTreeNode_NewInstance, METH_VARARGS,
   "V.NewInstance() -> vtkGeoTreeNode\nC++: vtkGeoTreeNode *NewInstance()\n\n"},
  {"SetId", PyvtkGeoTreeNode_SetId, METH_VARARGS,
   "V.SetId(int)\nC++: virtual void SetId(unsigned long _arg)\n\nThe id uniquely specified this node. For this implementation I am\ngoing to store the branch path in the bits.\n"},
  {"GetId", PyvtkGeoTreeNode_GetId, METH_VARARGS,
   "V.GetId() -> int\nC++: virtual unsigned long GetId()\n\nThe id uniquely specified this node. For this implementation I am\ngoing to store the branch path in the bits.\n"},
  {"SetLevel", PyvtkGeoTreeNode_SetLevel, METH_VARARGS,
   "V.SetLevel(int)\nC++: virtual void SetLevel(int _arg)\n\nKnowing the level simplifies encoding the branch trace in the Id.\n"},
  {"GetLevel", PyvtkGeoTreeNode_GetLevel, METH_VARARGS,
   "V.GetLevel() -> int\nC++: virtual int GetLevel()\n\nKnowing the level simplifies encoding the branch trace in the Id.\n"},
  {"SetLongitudeRange", PyvtkGeoTreeNode_SetLongitudeRange, METH_VARARGS,
   "V.SetLongitudeRange(float, float)\nC++: void SetLongitudeRange(double, double)\nV.SetLongitudeRange((float, float))\nC++: void SetLongitudeRange(double a[2])\n\n"},
  {"GetLongitudeRange", PyvtkGeoTreeNode_GetLongitudeRange, METH_VARARGS,
   "V.GetLongitudeRange() -> (float, float)\nC++: double *GetLongitudeRange()\n\n"},
  {"SetLatitudeRange", PyvtkGeoTreeNode_SetLatitudeRange, METH_VARARGS,
   "V.SetLatitudeRange(float, float)\nC++: void SetLatitudeRange(double, double)\nV.SetLatitudeRange((float, float))\nC++: void SetLatitudeRange(double a[2])\n\n"},
  {"GetLatitudeRange", PyvtkGeoTreeNode_GetLatitudeRange, METH_VARARGS,
   "V.GetLatitudeRange() -> (float, float)\nC++: double *GetLatitudeRange()\n\n"},
  {"SetChild", PyvtkGeoTreeNode_SetChild, METH_VARARGS,
   "V.SetChild(vtkGeoTreeNode, int)\nC++: void SetChild(vtkGeoTreeNode *node, int idx)\n\nGet a child of this node. If one is set, then they all should\nset.  No not mix subclasses.\n"},
  {"SetParent", PyvtkGeoTreeNode_SetParent, METH_VARARGS,
   "V.SetParent(vtkGeoTreeNode)\nC++: void SetParent(vtkGeoTreeNode *node)\n\nWhen we merge children to a lower resolution parent, we need this\nreference.  It is not referenced counted to avoid reference\nloops. A child should never exist when the parent is destructed\nanyway.\n"},
  {"SetOlder", PyvtkGeoTreeNode_SetOlder, METH_VARARGS,
   "V.SetOlder(vtkGeoTreeNode)\nC++: void SetOlder(vtkGeoTreeNode *node)\n\nManage links to older and newer tree nodes. These are used to\nperiodically delete unused patches.\n"},
  {"GetOlder", PyvtkGeoTreeNode_GetOlder, METH_VARARGS,
   "V.GetOlder() -> vtkGeoTreeNode\nC++: vtkGeoTreeNode *GetOlder()\n\n"},
  {"SetNewer", PyvtkGeoTreeNode_SetNewer, METH_VARARGS,
   "V.SetNewer(vtkGeoTreeNode)\nC++: void SetNewer(vtkGeoTreeNode *node)\n\n"},
  {"GetNewer", PyvtkGeoTreeNode_GetNewer, METH_VARARGS,
   "V.GetNewer() -> vtkGeoTreeNode\nC++: vtkGeoTreeNode *GetNewer()\n\n"},
  {"HasData", PyvtkGeoTreeNode_HasData, METH_VARARGS,
   "V.HasData() -> bool\nC++: virtual bool HasData()\n\nReturns whether this node has valid data associated with it, or\nif it is an \"empty\" node.\n"},
  {"DeleteData", PyvtkGeoTreeNode_DeleteData, METH_VARARGS,
   "V.DeleteData()\nC++: virtual void DeleteData()\n\nDeletes the data associated with the node to make this an \"empty\"\nnode. This is performed when the node has been unused for a\ncertain amount of time.\n"},
  {"GetWhichChildAreYou", PyvtkGeoTreeNode_GetWhichChildAreYou, METH_VARARGS,
   "V.GetWhichChildAreYou() -> int\nC++: int GetWhichChildAreYou()\n\nGet this nodes child index in node's parent.\n"},
  {"IsDescendantOf", PyvtkGeoTreeNode_IsDescendantOf, METH_VARARGS,
   "V.IsDescendantOf(vtkGeoTreeNode) -> bool\nC++: bool IsDescendantOf(vtkGeoTreeNode *elder)\n\nThis method returns true if this node descends from the elder\nnode.  The decision is made from the node ids, so the nodes do\nnot have to be in the same tree!\n"},
  {"CreateChildren", PyvtkGeoTreeNode_CreateChildren, METH_VARARGS,
   "V.CreateChildren() -> int\nC++: int CreateChildren()\n\nCreate children of the same type as parent. Id, level and\nLatitude-Longitude ranges are set. Returns VTK_ERROR if level\ngets too deep to create children.\n"},
  {"GetChildTreeNode", PyvtkGeoTreeNode_GetChildTreeNode, METH_VARARGS,
   "V.GetChildTreeNode(int) -> vtkGeoTreeNode\nC++: vtkGeoTreeNode *GetChildTreeNode(int idx)\n\nGet the child as a vtkGeoTreeNode. Subclasses also implement\nGetChild() which returns the child as the appropriate subclass\ntype.\n"},
  {"GetParentTreeNode", PyvtkGeoTreeNode_GetParentTreeNode, METH_VARARGS,
   "V.GetParentTreeNode() -> vtkGeoTreeNode\nC++: vtkGeoTreeNode *GetParentTreeNode()\n\nGet the parent as a vtkGeoTreeNode. Subclasses also implement\nGetParent() which returns the parent as the appropriate subclass\ntype.\n"},
  {"GetStatus", PyvtkGeoTreeNode_GetStatus, METH_VARARGS,
   "V.GetStatus() -> NodeStatus\nC++: NodeStatus GetStatus()\n\n"},
  {"SetStatus", PyvtkGeoTreeNode_SetStatus, METH_VARARGS,
   "V.SetStatus(NodeStatus)\nC++: void SetStatus(NodeStatus status)\n\n"},
  {"ShallowCopy", PyvtkGeoTreeNode_ShallowCopy, METH_VARARGS,
   "V.ShallowCopy(vtkGeoTreeNode)\nC++: virtual void ShallowCopy(vtkGeoTreeNode *src)\n\nShallow and Deep copy. Deep copy performs a shallow copy of the\nChild nodes.\n"},
  {"DeepCopy", PyvtkGeoTreeNode_DeepCopy, METH_VARARGS,
   "V.DeepCopy(vtkGeoTreeNode)\nC++: virtual void DeepCopy(vtkGeoTreeNode *src)\n\nShallow and Deep copy. Deep copy performs a shallow copy of the\nChild nodes.\n"},
  {nullptr, nullptr, 0, nullptr}
};

static PyTypeObject PyvtkGeoTreeNode_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  "vtkGeovisCorePython.vtkGeoTreeNode", // tp_name
  sizeof(PyVTKObject), // tp_basicsize
  0, // tp_itemsize
  PyVTKObject_Delete, // tp_dealloc
  0, // tp_vectorcall_offset
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  nullptr, // tp_hash
  nullptr, // tp_call
  PyVTKObject_String, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  PyObject_GenericSetAttr, // tp_setattro
  &PyVTKObject_AsBuffer, // tp_as_buffer
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_HAVE_GC|Py_TPFLAGS_BASETYPE, // tp_flags
  PyvtkGeoTreeNode_Doc, // tp_doc
  PyVTKObject_Traverse, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  offsetof(PyVTKObject, vtk_weakreflist), // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  PyVTKObject_GetSet, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  offsetof(PyVTKObject, vtk_dict), // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyVTKObject_New, // tp_new
  PyObject_GC_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static vtkObjectBase *PyvtkGeoTreeNode_StaticNew()
{
  return vtkGeoTreeNode::New();
}

PyObject *PyvtkGeoTreeNode_ClassNew()
{
  PyVTKClass_Add(
    &PyvtkGeoTreeNode_Type, PyvtkGeoTreeNode_Methods,
    "vtkGeoTreeNode",
 &PyvtkGeoTreeNode_StaticNew);

  PyTypeObject *pytype = &PyvtkGeoTreeNode_Type;

  if ((pytype->tp_flags & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

#if !defined(VTK_PY3K) && PY_VERSION_HEX >= 0x02060000
  pytype->tp_flags |= Py_TPFLAGS_HAVE_NEWBUFFER;
#endif

  pytype->tp_base = (PyTypeObject *)PyvtkObject_ClassNew();

  PyObject *d = pytype->tp_dict;
  PyObject *o;

  PyType_Ready(&PyvtkGeoTreeNode_NodeStatus_Type);
  PyvtkGeoTreeNode_NodeStatus_Type.tp_new = nullptr;
  vtkPythonUtil::AddEnumToMap(&PyvtkGeoTreeNode_NodeStatus_Type);

  o = (PyObject *)&PyvtkGeoTreeNode_NodeStatus_Type;
  if (PyDict_SetItemString(d, "NodeStatus", o) != 0)
  {
    Py_DECREF(o);
  }

  for (int c = 0; c < 2; c++)
  {
    typedef vtkGeoTreeNode::NodeStatus cxx_enum_type;

    static const struct { const char *name; cxx_enum_type value; }
      constants[2] = {
        { "NONE", vtkGeoTreeNode::NONE },
        { "PROCESSING", vtkGeoTreeNode::PROCESSING },
      };

    o = PyvtkGeoTreeNode_NodeStatus_FromEnum(constants[c].value);
    if (o)
    {
      PyDict_SetItemString(d, constants[c].name, o);
      Py_DECREF(o);
    }
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkGeoTreeNode(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkGeoTreeNode_ClassNew();

  if (o && PyDict_SetItemString(dict, "vtkGeoTreeNode", o) != 0)
  {
    Py_DECREF(o);
  }

}

